JPEGView Changelog
******************

[1.3.46] 2023-10-06
New features:
- Add support for more RAW image formats with LibRaw, ex: CR3 (ICC profiles are supported)
  PR #211, thanks qbnu (GH https://github.com/qbnu)
- Add basic support for PSD (Adobe Photoshop Document)
  Color modes supported: Grayscale, RGB, CMYK, Multichannel, Duotone, Lab
  8-bit depth PSDs only
  Compression modes supported: Raw/Uncompressed, RLE
  (See PR for detailed supported/unsupported breakdown)
  PR #233, thanks qbnu (GH https://github.com/qbnu)
- Add support for reading EXIF data from JXL, HEIF, AVIF, WebP and PNG files
  PR #213, thanks qbnu (GH https://github.com/qbnu)
- Misc EXIF Metadata fixes:
  * GPS info parsed from RAW metadata
  * GPS coordinates in degrees+decimal minutes will now be converted to degrees+minutes+seconds
  * Altitudes below sea level will now show negative
  * Metadata will be shown for either RAW or JPEG, with RAW taking precedence
  PR #211, thanks qbnu (GH https://github.com/qbnu)
- RAW metadata's acquisition date shown in window title
  PR #242, thanks qbnu (GH https://github.com/qbnu)
- Add multithreading when decoding with libavif and reduced memory usage
  Up to ~20% decoding speed improvement
  PR #204, thanks qbnu (GH https://github.com/qbnu)
- Optimize JXL and HEIF RGBA -> BGRA conversion
  Speed up ~25% for JXL and ~150% for HEIF
  PR #234, thanks qbnu (GH https://github.com/qbnu)
- New INI file setting: "WindowBorderlessOnStartup"
  On startup, set JPEGView window to borderless mode (title bar hidden)
- New INI file setting: "WindowAlwaysOnTopOnStartup"
  On startup, set JPEGView window to be always on top
Bugs fixed:
- Adjust animation frame times to appear closer to their actual values
  Accounts for time spent processing frame.  (Minimum frame time is 10ms due to technical limitations)
  PR #205, thanks qbnu (GH https://github.com/qbnu)
Changed behavior:
- INI Option: "UseEmbeddedColorProfiles"=true can be used without losing aPNG support
  ICC profiles are not supported for Animated PNG
  PR #202, thanks qbnu (GH https://github.com/qbnu)
- Renamed INI Option: "OverrideOriginalFileWithoutSaveDialog" -> "OverwriteOriginalFileWithoutSaveDialog"
  (`overwrite`, not `override` the file)
- Renamed INI Option: "TrimWithoutPromptLosslessJPEG" -> "CropWithoutPromptLosslessJPEG"
  (`crop` is the common image term, even if `trim` is used internally in some libraries)
Other changes:
- Updated to library versions:
  * libavif 1.0.1
  * libde265 1.0.12
  * libjxl 5d20fbe
  * libpng 1.6.40
  * libwebp 1.3.2 (Fixes CVE-2023-4863)
  * zlib 1.3
  PR #235, thanks qbnu (GH https://github.com/qbnu)
- Official scoop.sh support in bucket `extras/jpegview-fork`
  PR #223, thanks Tim Martin (GH https://github.com/t-mart)
Localization updates:
- New language: "sl" Slovenian, thanks Jadran Rudec
- New language: "tr" Turkish, thanks Kaya Zeren
- New language: "bg" Bulgarian, thanks Ivan Georgiev
- New translation: "sr" Serbian, thanks Ljuba Cirovic
- New translation: "hu" Hungarian, thanks József Ujvári
- New translation: "fi" Finnish, thanks Kari Eveli
- New translation: "sk" Slovak, thanks Marián Hikaník
- New translation: "ta" Tamil, thanks Nirmal G.
- Updated Japanese translation, thanks maboroshin (GH https://github.com/maboroshin)
- Updated Korean translation, thanks VenusGirl (GH https://github.com/VenusGirl)
- Updated Russian translation, thanks Dmitry Yerokhin
- Updated Chinese (Taiwan) translation, by converting chs -> cht
- Updated French translation, thanks Ronan Plantec
- Updated Greek translation, thanks Michalis
- Updated Polish translation, thanks Marcin Czerwien
- Rename INI option: "bel" -> "be" (official ISO 639-1 naming)
- Rename language: "Belorussian" to "Belarusian" (officially renamed in 1991)

[1.2.45] 2023-03-04
New features:
- Add support for ICC Profiles embedded in WebP, JPEG XL, HEIF/HEIC and AVIF images.
  Set INI option UseEmbeddedColorProfiles=true to enable.
  NOTE: Currently, this option will disable Animated PNG support due to usage of GDI+ (see 1.1.44 release notes)
  PR #156, thanks qbnu (GH https://github.com/qbnu)
Bugs fixed:
- Fixed: Freeze in JPEGView when "CPUType" set/auto-detected as AVX2, HighQualityResampling=true, and window width is > 3200 pixels (either spanned over multi-monitor or on a single monitor).
  (This outstanding bug had been extensively reported since v1.0.35+.  Thanks to everyone who provided samples, videos, and system configurations to help identify the specific conditions necessary to trigger this bug!)
- Fixed: Regression introduced in 1.1.44 which caused "Fit Image to Screen" to create a tiny window
  instead of a window which filled the screen.
- Fixed: In certain cases with certain image, after zooming out to 0% (as far as allowed), zooming in did not work and got stuck at 0%
- Fixed: "FileNameFormat" INI option "%filesize%" substitution now shows MB when exceeding 1 MB, not 100 MB
Other changes:
- Updated French translation, thanks LaurentGrenet (GH https://github.com/LaurentGrenet)

[1.1.44] 2023-02-27
New features:
- Add support for Animated AVIF (AVIF Sequence)
  PR #143, thanks qbnu (GH https://github.com/qbnu)
- QOI (Quite OK Image) Read/Write support, (also supported on XP)
  PR #150, thanks qbnu (GH https://github.com/qbnu)
- New Mouse Gesture: CTRL + SHIFT + LMouse Drag => Instantly zoom into selected area
  Modified backport feature from fork by David Neon (GH https://github.com/sdneon)
- New Crop options: Fixed to image aspect ratio (actual ratio displays in menu), 7:5 (common print ratio), 1:1 (common web size)
- New INI file setting: "FlashWindowAlert"
  When WrapAroundFolder=false, briefly flash window when attempting to navigate beyond the beginning or end of the file list.
  (Default to enabled, since it's visual UI feedback)
- New INI file setting: "BeepSoundAlert"
  When WrapAroundFolder=false, play the system beep sound when attempting to navigate beyond the beginning or end of the file list.
  (Default to disabled, since audio feedback can be an annoyance)
- When using a fixed crop mode, and resizing of crop/selection box:
  Dragging the handles in Top-Left and Bottom-Right will change to portrait or landscape orientation if dragging in the direction to "pull" the crop into the other orientation.  (Top-Left pull by w, Bottom-Right pull by h)
  (Effectively doubles the aspect ratios natively supported into portrait orientations)
Bugs fixed:
- Fixed: Transparency color for some image types was reversed BGR
  PR #145, thanks qbnu (GH https://github.com/qbnu)
- Fixed: TGA used background color for transparency instead of transparency color
- When viewing the last frame of a multi-frame image, at the end of the file list, with option WrapAroundFolder=false, attempting to navigate to the next frame will no longer loop back to frame 0
Changed behavior:
- Restores ICC Profile support for PNGs by using GDI+ when ForceGDIPlus=true or UseEmbeddedColorProfiles=true options set.  NOTE: Disables animated PNG support.
  PR #149, thanks qbnu (GH https://github.com/qbnu)
- When cursor is visible (not in full screen) always zoom to cursor when executing command IDM_TOGGLE_FIT_TO_SCREEN_100_PERCENTS (Spacebar by default)
  Previous behavior: Always zoomed to center when a new image was loaded
- Replaced INI option "IsSortedUpcounting" with "FileSortAscending" (it is an English translatable word, and clearer on what it is related to)
- When renaming, either by clicking on the filename on the bottom panel, or a keymap to IDM_RENAME, only select the filename part without the extension part for easier renaming
- Completely unbound the zoom. Previously allowed: 10% - 1600%
  Zoom out: Unlimited to as small as possible
  Zoom in: Unlimited as long as the image "rescaled" by zoom factor is < 65535 in any dimension (internal limitation)
- Crop ratios submenu is now sorted by increasing ratios, from square (1:1) to increasingly oblong
Other changes:
- New INI file setting: "ZoomPausePercent"
  The default behavior of JPEGview is to briefly pause at 100% when continuously zooming in or out. (This ensures you can always get to perfectly 100%)
  This new setting allows the user to configure to a different percentage, or disable to zoom continuously with no interruption
- Reorder JPEGView.ini options grouping similar options and adding comment headers
  Options should be easier to find and logically grouped. Previously, options were haphazardly added and weren't sorted in any particular order
  (It might be a little painful to move your existing options over to the new INI format, but future options will be much easier to find!)
  (Your existing INI will continue to work, if you choose to continue to use it, but you'll have to add in new options manually)
- Updated Russian translation, thanks Dmitry Yerokhin
- Updated Japanese translation, thanks maboroshin (GH https://github.com/maboroshin)
- Updated Chinese Simplified translation, thanks dukeng (GH https://github.com/dunkeng)
- New strings.txt English reference for translators, it will always be current to the code
- Second part of movie/slideshow menus now translatable
- Updated to Turbo JPEG library version 2.1.91 (2023-02-08)
- Updated to JPEG XL library version 0.8.1 (2023-02-03)
- Devs: Translation scripts to sync with code, regenerate at any time, and added some features to make translating easier, like missing and unused text
Installer Changes:
- Add all built-in supported file extensions to Window's "Open With >" submenu
- Add "Edit with JPEGView" option to Windows Explorer for all extensions JPEGView can save to
- 64-bit installs into "C:\Program Files" on new installs (existing installs will use previous install location)

[1.1.43] 2023-02-06
New features:
- HEIF/AVIF support
  Supports AV1/HEVC encoded still images and image collections
  (Not yet supported: thumbnails, animations, or AVC encoded images)
  (NOTE: Microsoft Visual C++ Runtime vcruntime140.dll required)
  PR #109, thanks qbnu (GH https://github.com/qbnu)
Changed behavior:
- KeyMap.txt is now optional, the defaults from KeyMap.txt.default will be loaded if a user-customized version does not exist
  KeyMap.txt search paths: %AppData%\JPEGView\KeyMap.txt -> (JPEGView.exe dir)\KeyMap.txt -> (JPEGView.exe dir)\KeyMap.txt.default
  (This means, extracting new releases will not overwrite your customized KeyMap.txt)
- KeyMap.txt is now simplified to only the include key mappings.  The list of commands and help can be found in the KeyMap-README.html
  (KeyMap.txt from older versions will continue to work if you have customized one)
- Help Display now properly shows the on/off status of "hide window title bar" and "always on top" modes
Other changes:
- Updated French translation, thanks LaurentGrenet (GH https://github.com/LaurentGrenet)
- Updated Japanese translation, thanks maboroshin (GH https://github.com/maboroshin)
- Updated Russian translation, thanks Dmitry Yerokhin
- Windows XP is still supported and special WinXP-compatible builds will be released (WinXP builds do not support new formats added after v1.0.37.1)
- WebP is now integrated into JPEGView without needing webp.dll
  PR #128, thanks qbnu (GH https://github.com/qbnu)

[1.1.42] 2023-01-26
New features:
- JPEG XL support, with animation
  (NOTE: Microsoft Visual C++ Runtime vcruntime140.dll required when opening
  JPEG XL files.  Most Windows 10+ systems have this installed already.
  Otherwise, download it for free from Microsoft.)
  PR #99, thanks qbnu (GH https://github.com/qbnu)
- Add a new command "Hide window title bar"
  Default shortcut key: "SHIFT+F11"
  This toggles JPEGView window to show or hide title bar.
  NOTE: in this mode, you cannot resize the window (although full screen is still supported)
- Add a new mouse gesture to move the JPEGView window at any time: ALT+LeftClick
  This allows moving the window without directly clicking on the title bar (or if title bar is hidden).
- Add a new command "Always on Top"
  Default shortcut key: "SHIFT+F12"
  This toggles the JPEGView window to display above all other windows, even when not in focus
- Add new command "Copy file path"
  Default shortcut key: "CTRL+SHIFT+C"
  This copies file path of the image to clipboard
  PR #62, thanks Trevor Kropp (GH https://github.com/kropptrevor)
Changed behavior:
- Animated formats: frame durations <= 10ms are set to 100ms
  (Matches behavior of most web browers)
  PR #108, thanks qbnu (GH https://github.com/qbnu)
Other changes:
- New INI file setting: "ShowFilePathInTitle"
  Show full file path and name in the window title
  (shows only file name by default)
- New INI file setting: "DefaultSelectionMode"
  Allows for disabling the default selection mode behavior when clicking on an image in JPEGView.
  Set to false to use selection mode only when CTRL is pressed, to prevent unintended cropping/zooming.
  (CTRL+LeftClick always results in selection, regardless of image zoom)

[1.1.41.1] 2023-01-03
Bugs fixed:
- Fixed regression introduced in 1.1.41 which caused CR2 and DNG files
  failing to open due to magic bytes detecting them as TIFF files.
Other changes:
- Updated French localization string for command added in 1.0.39 (GH #58)

[1.1.41] 2022-12-31
Bugs fixed:
- Stop animation/slideshow state when opening file.
  Prevents still images in a folder unintentionally played like an animation.
  Bug documented in PR #95, thanks qbnu (GH https://github.com/qbnu)
New features:
- Animated WebP support
  Different durations for each frame supported
  Caches decoder for speed improvement on loading large files
  PR #90, thanks qbnu (GH https://github.com/qbnu)
- Animated PNG support
  Animation of 0ms delay defaults to 100ms, like major web browsers
  PR #96, thanks qbnu (GH https://github.com/qbnu)
Changed behavior:
- Check magic bytes to open file for PNG, GIF, and TIFF before falling back to extension.
  PR #93, thanks qbnu (GH https://github.com/qbnu)
Other changes:
- Updated to Turbo JPEG version 2.1.4 (8/12/2022)
- Updated to Google's WebP library version 1.3.0-rc1 HEAD at commit b557776 (12/20/2022)

[1.0.40] 2022-03-30
Other changes:
- Created new MSI installer for JPEGView using WiX.  It's rudimentary, but functional.
- Updated Japanese translation, thanks maboroshin (GH https://github.com/maboroshin)
- Updated to latest dcraw 9.28 (6/1/2018)
  PR #30, thanks kakuty (GH https://github.com/doyaGu)
- Updated to Turbo JPEG version 2.1.3 (2/25/2022)
- Updated to Google's WebP library version 1.2.2 HEAD at commit 7a68afa (3/21/2022)
Misc changes:
- Submitted MSI installer to official Microsoft WinGet repositories.
  Use "winget install jpegview" on Windows 10 1709+, or Windows 11 to use.
- Updated repository README.md with official releases info.
- Split "readme.txt" which contained the changelog to "CHANGELOG.txt",
  and created "COMPILING.txt" for source compile instructions.
- Added known dates for all past releases into CHANGELOG.txt
- Updated some links in readme.html, and homepage link in About dialog

[1.0.39.1] 2022-02-11
Bugs fixed:
- Fixed bug introduced in 1.0.39 which caused other menu items in the popup to disappear

[1.0.39] 2022-02-10
New features:
- Add new command "Open containing folder in Explorer"
  Default shortcut key: "W"
  This pops up and selects the file in Windows Explorer.
Other changes:
- Updated to Turbo JPEG version 2.1.2 (11/18/2021)
- Updated to Google's WebP library version 1.2.2 HEAD at commit ec178f2 (2/2/2022)

[1.0.38] 2022-01-30
Bugs fixed:
- INI: Removed quotes around ColorCorrection setting.
  Values enclosed in quotes are ignored and hardcoded defaults are used.
  PR #12, thanks oughtsz (GH https://github.com/oughtsz)
New features:
- Adds transparency support for WEBP format.
  Honors "TransparencyColor" INI setting.
  PR #27, thanks KrokusPokus (GH https://github.com/KrokusPokus)
Other changes:
- Updated Greek translation, thanks George (SF https://sourceforge.net/u/geonetor/)
- Updated Chinese Simplified translation, thanks dukeng (GH https://github.com/dunkeng)
- Rename Russian INI template to match localized INI naming convention
- Added LICENSE.txt to explicitly specify the GPLv2 copyright

[1.0.37.1] 2021-05-11
Other changes:
- First release from sylikc's GitHub
- Using Visual Studio 2019 Community Edition to compile
- Updated to Turbo JPEG version 2.1.0 (4/23/2021)
- Updated to Google's WebP library version 1.2.0 HEAD at commit 05b72d4 (4/28/2021)

[1.0.37] 2018-02-24
New features:
- Support for display of GPS coordinates/altitude of JPEG images
  Location can be shown on map in browser, use new INI setting 'GPSMapProvider' to configure
Other changes:
- New INI file setting: MouseWheelZoomSpeed
- New command in keymap.txt: IDM_TOGGLE_FILL_WITH_CROP_100_PERCENTS
- %exepath% placeholder can be used in IniEditor setting
- Reading whole INI file with a single API call
- Reading ISO EXIF tag 0x8833 that stores high ISO values

[1.0.36] 2017-12-28
Bugs fixed:
- Fixed problem with EXIF rotation combined with 'Keep parameters' mode (F4).
- Fixed bug causing wrong image display when minimal display time was set in windowed mode.
- Fixed bug with navigation mode 'Show Subfolders' and 'Show siblings' and WrapAroundFolder=true.
- Could not load file on command line in current folder without leading .\
- Made printing more robust when no default printer defined
Other changes:
- "Set current parameters as default values": Saving more parameters to INI file
- Alt+R to resume stopped slide show.
- New INI file settings:
  SkipFileOpenDialogOnStartup
    Set to true to skip the 'Open' dialog when starting JPEGView
  LandscapeMode
    Set to true to turn on landscape enhancement mode by default
  IniEditor
    Sets the application to use for editing INI files
- New command line parameters: /ini [INI file title]
    Allows using alternative INI files
- Improved precision of fixed point arithmetic in up- and downsampling filters
  Using more filter kernels for upsampling, thus allowing larger upsampling factors (> 30)

[1.0.35.1] 2016-04-04
Bugs fixed:
- 64 bit version did not work on CPUs not supporting AVX

[1.0.35] 2016-04-01
Bugs fixed:
- Fixed font handle leak, preventing display of movies with more than 5000 frames when EXIF display was enabled during movie playing
- Reading/saving auto zoom mode correctly from/to INI file
- Showing zoom factor correctly during slide shows (when shown in Ctrl-F2 display)
New features:
- Support for AVX2 (256 bit SIMD) on processors providing this instruction set (Haswell and later). 64 bit version only!
- New admin menu item: Update user setting
  Updates the user settings with new settings from INI template file, while preserving all existing user settings.
Other changes:
- Increased maximum image size to 500 MPixels for 64 bit version
- Increased maximum JPEG comment length to 4096 characters
- Changed Ctrl-F11 behavior when 'Fit window to image' is on but window does not fit image: Makes window fitting
- Readme.html uses css
- Help display (F1) now uses own window
- Updated Spanish translation, thanks to Enrique

[1.0.34] 2016-01-03
Bugs fixed:
- Window frame remains visible when starting in full screen mode and using classic windows style
- Fit to screen is kept with 'Keep parameters' when zoom is required in full screen mode
- Removing image from read-ahead cache when it was destructively processed so that it gets reloaded next time it is accessed
New features:
- Printing: Fill with crop mode and ability to move the image with the mouse within the printable area
- JPEG comment segment is taken over from existing JPEG when saving to new JPEG
- Showing some meta data for camera RAW images with F2
- Considering image orientation from camera RAW images
- Japanese translation, thanks to Hiroyuki Matenokoji
- Polish translation, thanks to Damian
- New INI file settings:
  - SingleFullScreenInstance=true/false
    Allows multiple instances of JPEGView to run in full screen mode
  - UserCropAspectRatio=x y
    Sets the user crop aspect ratio, x and y are integers
  - TransparencyColor=R G B
    Color used for transparent parts of images
  - ShowEXIFDateInTitle=true/false
    Show/Hide the acquisition date from EXIF data in the window title
  - WallpaperPath=path
    Set path to store desktop wallpaper image
  - AutoZoomModeFullscreen
    Set auto zoom mode for fullscreen mode differently than auto zoom mode for windowed mode

[1.0.33] 2015-01-07
Bugs fixed:
- Error when deletion of file fails (e.g. because it is on a read-only storage)
New features:
- Support for image printing
- Free rotation is now stored in the parameter DB if no destructive processing (e.g. crop) has been applied before
- Free rotation can be chained without error propagation because image is reloaded before rotation is applied.
  This only applies if no destructive processing (e.g. crop) has been applied in the processing chain.
- New INI file settings:
  - MinimalWindowSize=width height
    Allows setting the minimal window size in pixels
  - MinimalDisplayTime = value
    Minimal display time of an image when using the PgDn/PgUp keys (in milliseconds [0..1000 ms])
Other changes:
- Hiding parameter DB buttons when image is processed destructively as these operations cannot be stored in the
  parameter DB.

[1.0.32.2] 2014-12-04
Bugs fixed:
- More tolerance on corrupt EXIF data offsets - image is now displayed in this case (without EXIF of course)
- Showing mouse cursor before asking for confirmations if mouse cursor was off before
- ESC works again when no image is loaded into JPEGView (e.g. because the last image in a folder was deleted)
- Taking DisplayMonitor into account also in windowed mode, not only fullscreen mode
- Using forced sort order on command line (e.g. /order Z) also for slideshow lists
New features:
- Set current image as desktop wallpaper
  You can either set the original image (in Windows XP only BMP is supported) or the processed image as displayed.
  The later is using also the size as displayed.
Other changes:
- Removed 'Edit global settings' menu entry. This has led to confusion as users unintentionally edit the global
  INI file instead of the user INI file and wonder why the settings are not working.
  If you need this menu item, set AllowEditGlobalSettings=true in the INI file to force showing it.
- Batch rename dialog: Supporting %h and %min placeholders for hour and minute of modification date

[1.0.32.1] 2014-03-28
Bugs fixed:
- Prefetching image of correct size in windowed mode - prefetching was actually not working in this situation
  and thus performance was poor in 1.0.32 in windowed mode.
- Auto-zoom-mode 'Fill with crop': Handling portrait orientation images correctly in all cases
Other changes:
- Expanding environment variables in user commands and open with commands
- New command available for mapping to a key: IDM_RENAME to rename current file.
  By default this command is not mapped to a key and only available by clicking on the file name on the bottom panel.
- Finer granularity control over deleting files (confirmations, availability)
  AllowFileDeletion=false : Allows disabling file deleting in JPEGView
  DeleteConfirmation=Always/OnlyWhenNoRecycleBin/Never : Controls confirmation when deleting with navigation panel button
- When deleting files with the navigation panel button (x), a confirmation is required for files that are deleted permanently.
  This is the case for drives that have no recycle bin, like memory sticks or network drives.
- Updated Portuguese translation

[1.0.32.0] 2014-03-21
Bugs fixed:
- Window size in windowed mode was some pixels too small due to invalid reporting of window border size by OS
- Fixed wrong line break in file titles in info panel for long file names
- SingleInstance=true, fixed error on loading image in case window was minimized
- Lossless JPEG-transformations cannot be applied anymore after the original pixels have been modified, e.g. by a crop.
  Applying the transformations in this case would lead to unexpected results.
New features:
- 64 bit version (in addition to existing 32 bit version)
- New image processing: Change size (in menu Transform image > Change size)
- Improvements in image file deletion:
  - Button on navigation panel and 'Del' key deletes the current image file in the same same way Explorer does (by moving to recycle bin)
  - 'Shift+Del' deletes the current image file permanently
- Showing keyboard shortcuts in tooltips of the toolbox buttons
- Traditional Chinese (Taiwan) translation and updated Chinese translation
Other changes:
- Settings/Admin > Set as default viewer: Calls the file association dialog from control panel to perform
  the associations in Windows 8, because this is the only way under Windows 8 to properly change file associations.
- Ctrl-X also copies the file name to the clipboard (as Ctrl-C)
- Using Visual Studio 2013 to compile the 64 bit version

[1.0.31.1] 2014-02-26
Bugs fixed:
- Fixed crash when deleting files in 'Show folders and subfolders' navigation mode
- Filenames with \t in path are now displayed correctly when using customized file name display format
New features:
- JPEGView is now fully high DPI capable (e.g. 200 % -> 192 dpi) and scales all GUI elements properly to high DPI settings.
  This fixes problems on high DPI screens.
- Ctrl-C also copies the file name to the clipboard so that Windows Explorer is able to paste the original file with Ctrl-V
Other changes:
- Moved menu item to store current parameters as default in INI file to 'Setting/Configuration' submenu

[1.0.31] 2013-12-13
Bugs fixed:
- Read ahead no longer turned off when failed to read one image
- Fixed loading error of JPEGs with EXIF data and IDF1 section missing
- Blending issues with nVidia cards fixed (hopefully now works correctly in all situations)
- Fixed (sporadic) crash when deleting images permanently with the 'Del' key or when executing other user commands
- Registration of file extensions in Windows 8 improved. Consider however that Windows 8 protects the standard
  file associations. For changing these associations the 'Default programs' dialog of Windows 8 must be used.
- Showing system menu and icon in Windows7/8 when switching from full screen to windowed mode
New features:
- New supported file format: TGA (8, 15, 16, 24, 32 bits) - only for reading
- User commands extensions
  - Shortcuts with modifier keys can now be assigned to user commands. Shortcut format is as in the keymap, e.g. 'Ctrl+P'
  - User commands can optionally be bound to a menu item in the submenu 'User commands' in the JPEGView context menu
- 'Open with' menu
  - In Settings/Admin it is possible to define applications to be started in the 'Open with' submenu of the JPEGView context menu.
    The applications get passed the current image file name as argument on process startup.
    It is also possible to assign a shortcut key for such an application.
- Files can be sorted upcounting (default) or downcounting in all display order modes (by date, name, etc)
  - Can be set in the context menu of JPEGView
  - Stored to INI file
- New display order mode: Sort by file size
- New INI file setting:
  UseEmbeddedColorProfiles=[true/false]
  Setting this to true will enable color management for JPEG images and TIFF images (to the extend GDI+ supports it).
  Default is 'false' because enabling this setting has some disadvantages:
  - Turbo JPEG does not support embedded profiles, so GDI+ needs to be used what is much slower
  - GDI+ cannot read some valid JPEG files (e.g. some grayscale JPEGs, observed with Windows XP)
  Notice that GDI+ does not support V4 ICC color profiles in Windows XP. It does support these in Windows 7/8.
- New INI file settings:
  DefaultGUIFont=fontName fontSize [bold]
  FileNameFont=fontName fontSize [bold]
  Enables to change the GUI font, its size in points and its weight
- Esc key can now be re-defined in keymap (e.g. to display to 'Open file' dialog)
  Default remains to exit JPEGView
- Some minor changes in navigation panel appearance

[1.0.30] 2013-11-02
Bugs fixed:
- Fixed crash (leading to potential exploit) when image width or height is larger than 32767
- Improved zoom behavior for zoom < 10 %
- Slide shows with alpha blending: maybe now also works correctly if graphics driver implements alpha blending somewhat inexactly
- NoStrCmpLogical registry setting also checked in "LOCAL MACHINE" registry hive
- Fixed size cropping bug fixed
- Always registering JPEGView in registry when changing file assignments, thus fixing any invalid path, e.g. resulting from move
  of the EXE to another directory
- Animated GIFs and multiframe TIFFs can now be moved or deleted while displayed
New features:
- New command line parameter '/autoexit'. If passed, ESC key will terminate JPEGView also if a slideshow is running or an animated GIF is playing.
  Additionally it will auto-terminate JPEGView after the slideshow has finished when combined with the '/slideshow' command line parameter.
  Thanks to SourceForge user manuthie for implementing this.
- New command line parameter '/monitor [index]'. Shows JPEGView on the given monitor, overriding the INI file setting.
- New placeholders that can be used in user commands:
  %exepath% : Path to EXE folder where JPEGView is running
  %exedrive% : Drive letter of the EXE path, e.g. "c:"
- Displayed image is reloaded automatically when it changes on disk, using a file system change notifier.
  The image list of the current directory is also reloaded when images are added or deleted in this directory.
  To disable the file system notifier, set ReloadWhenDisplayedImageChanged=false in the INI file
- When canceling the 'Open file' dialog after startup, JPEGView is not terminated but an empty window is shown with some hints what to do.
  Can be used e.g. to paste images from clipboard.

[1.0.29] 2013-04-21
Bugs fixed:
- EXIF (F2) and file name info (Ctrl+F2) no longer flicker when active during slide show with transition effect
- No logical sorting of file names is done if HKEY_CURRENT_USER\Software\Microsoft\Windows\CurrentVersion\Policies\Explorer\NoStrCmpLogical
  registry value is set to 1. This matches the behavior of the Windows explorer.
  Note that the default registry value for this is 0, therefore almost all users will notice no change.
New features:
- Support for animated GIFs.
  Limitations:
  - Saving GIFs will only save the currently displayed frame.
  - Some image processings (e.g. free rotation, perspective correction) will stop the animation and work on a single frame only
  - No caching of the decoded frames. This has pros and cons. Pro is that memory consumption is limited. Con is that the CPU
    load while playing can be rather high. However on a dual core CPU it's not a problem.
- Support for multi-page TIFF. Note that (singlepage or multipage) TIFFs compressed with JPEG compression are not supported by GDI+.
  This is a known issue of GDI+ that cannot be fixed in JPEGView (except if another TIFF library would be used)
- New INI file setting: FileNameFormat allowing to display configurable information with Ctrl-F2. See INI file for information.
Other changes:
- WebP library 0.3.0 from Google is now used. This version supports lossy and lossless compression.
  To use lossless compression with the WEBP format, select the "WEBP lossless" file format in the "File Save" dialog.
  Be warned that lossless WEBP compression is very, very slow (decompression is fast however).

[1.0.28] 2013-03-15
Bugs fixed:
- Fixed bug in the window resizing code when 'DefaultWindowRect=max' and toggling between 100 % zoom and fit to window (space key)
- Fixed bug causing that zoom was not saved to parameter DB when auto fitting window to image was on
- Fixed bug that file pointer was invalid when deleting last file in folder and WrapAroundFolder=false in INI file
- New algorithm to guess encoding (UTF-8, ANSI) of JPEG comments when no encoding is explicitly specified
New features:
- Support for slide show transition effects (only in full screen mode)
  This can also be set in the INI file and on the command line, see readme.html for more info about command line parameters.
- File extensions can be registered to be opened by JPEGView over the 'Administration-Set as default viewer...' menu item
- New info button in top, left corner of screen in fullscreen mode to show EXIF info. EXIF into closable on the EXIF panel itself.
- When a supported camera RAW file was excluded in INI file but opened nevertheless in JPEGView (e.g. from explorer), the camera
  raw file type is added temporarily until program termination
- Russian translation of readme.html
- Improved Chinese translation

[1.0.27] 2013-01-20
Replaced Intel JPEG library by Turbo JPEG (tjpeg, http://sourceforge.net/projects/libjpeg-turbo/)
This replacement has many reasons:
- The Intel library license was not an open source type license
- Newer versions of the Intel library are not free of charge. The old versions are not supported by Intel anymore.
- Some JPEG files could not be read by the Intel library. tjpeg can read these files.
- There is no free 64 bit version of the Intel library.
  (This is important for the future when there may be a 64 bit version of JPEGView)
The tjpeg library is open source and (at least on modern CPUs) performs comparable to the Intel library. It is used by many other
viewers and several Linux distributions.
Note that tjpeg including lossless JPEG transformations has been statically linked to JPEGView. Therefore the application has grown
by 300 KB. However the total size of the package is lower than before because IJL15.dll and jpegtran.exe are no longer needed.

Bugs fixed:
- When a folder is called 'pictures.jpg' for example, JPEGView no longer tries to process this folder as image
- Exposure time display: When nominator and denominator are both big numbers, a fractional value is shown instead of bigNum/bigDenum
- Reading slideshow list files (txt) encoded with UTF-8 and UTF-16 (little endian only) correctly
- Reading slideshow list files (txt) using uppercase file endings for image files correctly
New features:
- Lossless JPEG transformations integrated into JPEGView. The jpegtran.exe application is no longer part of the distribution of JPEGView.
- Basque translation, thanks to Xabier Aramendi
- Chinese translation, thanks to Yia Guo
- Keymap.txt now also supports to remap mouse buttons to commands.
- New INI file setting: 'TrimWithoutPromptLosslessJPEG'. Set to true to trim image before lossless JPEG transformations if needed without
                        prompting the user for each image.
- New INI file setting: DefaultWindowRect=sticky to save and restore the window size and position in window mode
- New INI file setting: 'SingleInstance'. Set to true to open all images in one single instance (window) of JPEGView.
- New INI file setting: 'ShowBottomPanel'. Set to false to disable showing the bottom panel when hovering with the mouse on bottom part
  of window/screen.
  Default is true (as before, was not configurable).
- New INI file setting: 'MaxSlideShowFileListSizeKB'. Sets maximum size of slide show text files in KB.
- New INI file setting: 'ForceGDIPlus'. If true, use GDI+ for reading JPEGS. Note that using GDI+ is much slower than the tjpeg library!
- New command line parameters:
  /slideshow xx    Starts JPEGView in slideshow mode, xx denotes the switching time in seconds. Only use when providing a file name,
                   folder name or file list on the command line as first parameter.
                   Example: jpegview.exe "filelist.txt" /slideshow 2
  /fullscreen      Starts JPEGView in full screen mode, ignoring the INI file setting that is currently active
  /order x         Forces file ordering mode 'x', ignoring the INI file setting that is currently active
                   'x' can be M, C, N or Z, for the file ordering modes 'M:modification date', 'C:creation date', 'N:file name', 'Z:random'
                   Example: jpegview.exe c:\pictures /slideshow 2 /order z
                   Shows a slideshow of the files in the folder "c:\pictures" using random ordering and an interval of 2 seconds.
Other changes:
- Because the tjpeg static library cannot be linked with VS2005, JPEGView is now compiled with VS2010. If you are using Windows XP
  before SP2, install SP2 or keep using version 1.0.26.

[1.0.26] 2012-01-23
Bugs fixed:
- Lossless rotate and crop now works in folders containing Unicode characters in the path.
  Note that the file title must not contain Unicode characters due to the fact that jpegtrans.exe does not support this.
New features:
- Portuguese (Portugal) translation, thanks to Sérgio Marques
- Support for viewing embedded JPEG images in camera RAW files using code from the dcraw project (v8.86).
- Support for loading images using Windows Image Codecs (WIC). By default WIC is used to load JPEG XR files (also called
  High definition photo). When using Windows Vista or Windows 7, the Windows Camera Codec pack can be installed to get
  support for full size camera RAW images in JPEGView. Refer to the readme.html for instructions.
- New image processing: Perspective correction, use button on navigation panel to activate
- Rotation and perspective correction: Option to keep aspect ratio when auto cropping
- New INI file setting: 'AutoRotateEXIF' to disable auto rotation of images based on EXIF image orientation tag.
  Default is true (the EXIF auto rotation is supported since many versions, this setting is introduced to turn this off).
- New INI file setting: 'ScaleFactorNavPanel' to scale the navigation panel buttons, e.g. to make them larger on touch screens
- Clicking into the image (without dragging) toggles visibility of navigation panel
- Zoom by dragging mouse, activate with 'Shift-left mouse click' or with button on navigation panel
- Random sorting order for images within folder, can be used e.g. for random slideshow mode (activate with 'z' key)
- Improved crop handling: Crop rectangle can be resized using handles
- When in 'Adjust window to image' zoom mode and in window mode, the window adjusts automatically to zoomed image size while zooming
Other changes:
- Russian version of keymap and INI file (KeyMap_ru.txt, JPEGView_ru.ini) containing explanations in Russian. Be aware that
  these files must be renamed to KeyMap.txt and JPEGView.ini and copied over the original (English) versions when JPEGView shall use them.

[1.0.25.1] 2011-11-13
- Rollback to VS2005 to compile the project because of problems with Windows 7 and Windows XP before SP2.
  The Windows 7 issues can be solved by using the latest versions of Windows SDK, WTL and ATL but the XP issue can't.
  JPEGView will remain on VS2005 at least for some versions.
  For VS2010 users, a solution and project file for VS2010 is included in the source code distribution.
  WebP library needs to be compiled with VS2010 as the VS2005 compiler produces crashing code from the Google source -
  so WebP will not work in XP SP1 or earlier.
- libwebp_a.dll made delay loaded - therefore JPEGView runs without this DLL when you do not need webp.

[1.0.25] 2011-11-13
Bugs fixed:
- Previous image now works correctly when WrapAroundFolder is set to false
New features:
- Czech translation, thanks to Milos Koutny
- Greek translation, thanks to Paris Setos
- WEBP image format supported (load and save), using the source code provided by Google
- Keyboard shortcuts are now defined in the file KeyMap.txt, located in the EXE folder. Users can edit the key map if desired.
- New INI file setting: ExchangeXButtons to exchange the forward and backward mouse buttons (default is true, now can be switched to false)
- Putting file name first in window title (as it is convention in Windows)
- Double-click to fit image to screen (according auto zoom mode currently set), respectively 100 % when already fit
- New transformations: Mirror horizontally and vertically (and put the rotation commands also under the new transformations submenu)
Other changes:
- After having had massive problems with a compiler bug when compiling the WEBP source code, I decided to switch to Visual Studio 2010.
  Install VS 2010 to compile JPEGView - Express Edition (free) is sufficient.

[1.0.24.1]
Bugs fixed:
- Crash fixed when zooming down images of some sizes to 10 %

[1.0.24] 2011-10-11
Bugs fixed:
- Navigation panel not truncated when window is small, instead the buttons are smaller.
  Tooltip texts are also no longer truncated in small windows.
- Modification date displayed with correct time zone adjustment
New features:
- Portuguese translation, thanks to Carpegieri Torezan
- New windowed mode that fits window size to image size, avoiding black borders.
  Enable in INI file using:
  DefaultWindowRect=image
- New auto full screen mode that starts JPEGView in fullscreen mode when the image is larger than the screen
  or in windowed mode (window fit to image) when the image is small enough to fit to the screen.
  Enable in INI file using:
  ShowFullScreen=auto
  Note: This is the new default value in the INI file.
Changed behaviour:
- In the EXIF display (F2), the file name is broken into multiple lines when it is very long
- F11 key is now used for toggling full screen (used to be Ctrl-W). Navigation panel visibility now uses Ctrl-N (instead of F11)
- If the first image shown is smaller than the screen, JPEGView now starts in 'window fit to image' mode.
  To restore the old behavior (always use fullscreen), set ShowFullScreen=true in INI file

[1.0.23] 2011-03-07
Bugs fixed:
- Improved memory handling for very large images. Read ahead turned off for very large images.
  Also improved memory footprint for processing large images by stripwise processing.
  Note that images > 100 MPixel still fail loading in most cases (tested with XP and 2GB memory)
- When out of memory, image loading fails with error message instead of crashing
- Set file modification time to EXIF time now correctly considers time zone
New features:
- New image processing: Rotation by arbitrary angle
  Using a button on the navigation panel, the image can be rotated with the mouse by a user-defined angle.
  The preview of rotation is real-time and uses simple point-sampling. When the rotation is applied to the
  image, bicubic interpolation is done, providing a good quality rotated image.
  Note that this processing cannot be stored in the parameter DB.
- Lossless crop
- Display of JPEG comments (EXIF user comment, EXIF image description, JPEG COM marker, in this order)
  Use INI file setting ShowJPEGComments to disable display of comments
- Set modification time to EXIF time for all files in folder
- New INI file setting: WrapAroundFolder.  Can be set to false to disable cyclic navigation
  within a folder (going from last to first image)

[1.0.22.1] 2011-02-16
Bugs fixed:
- Fixed crash on startup when ShowFullScreen=true in INI file
New features:
- Swedish translation (thanks to Ĺke)

[1.0.22] 2011-01-14
Bugs fixed:
- Copying EXIF data when saving image in screen size (Ctrl-Shift-S)
- Fixed crash when window is minimized while slideshow is playing
- Close button is active when moving mouse to top, right corner of screen
New features:
- Histogram can be displayed on the information panel (below EXIF information). Use ShowHistogram INI file entry
  to set if the histogram shall be shown on the panel or not. If not shown by default it can be blended in with
  a small button on the information panel.
- Updating EXIF thumbnail image when saving processed image
- New button on navigation panel: Keep processing parameters between images
- Changed behavior of fit to screen/actual size button, fit to screen is now default when not yet fit to screen
- Keeping fit to screen when resizing JPEGView window
- Image processing panel: Temporarily reset slider by clicking with the mouse on slider number
- Image processing panel: Reset slider to default value by double-clicking above slider
- Romanian translation (thanks to Silviu)
- Russian translation (thanks to Dmitry)
- Updated Spanish translation (thanks to Daniel)

[1.0.21] 2010-07-16
Bugs fixed:
- After saving, navigation panel was not painted correctly sometimes
New features:
- New image processing: Unsharp mask
  Using a button on the image processing panel, an unsharp mask can be applied to the original pixels.
  Note that preview is always in 100 % zoom. Unsharp masking cannot be stored in the parameter DB and it is not possible to
  apply unsharp masking automatically after loading each image (unlike other processings)
- New image processing: Color saturation
  Support includes: Saturation on image processing panel, default saturation in INI file, parameter DB and landscape picture mode
- UI colors can be set in INI file. New default colors instead of the traditional green.
  To restore the old colors, change them in the INI file to:
  GUIColor=0 255 0
  HighlightColor=255 255 255
  SelectionColor=255 255 0
  SliderColor=255 0 0
- New INI file setting: OverrideOriginalFileWithoutSaveDialog
  If set to true, Ctrl-S overrides the original file on disk, applying the current processings without showing a dialog or prompting the user to confirm.
  Use with care, the original file will be replaced by the processed file!

[1.0.20] 2010-06-01
Bugs fixed:
- Flag 'ReloadCurrent' used in user commands does no longer keep geometric parameters after reloading (zoom, pan, rotate)
New features:
- French translation
- Korean translation
- New INI file setting: DefaultSaveFormat to set the default format when saving images

[1.0.19] 2010-03-10
Bugs fixed:
- Corrected Italian translation
- Hiding of mouse cursor when starting up in window mode and switching to fullscreen mode
- Application shown in taskbar also when the file open dialog is displayed after startup
- File names having a & in the name are now displayed correctly
New features:
- 'DefaultWindowRect=max' in INI file will start with maximized window (if fullscreen mode is false)
- Dropping files or folders to JPEGView from Windows Explorer now works
- Edit global and user INI file using context menu
- Backup and restore/merge parameter DB using context menu
- Small buttons for minimize/restore/close on top, right corner of screen in full screen mode (only shown
  when mouse moved to top of screen)
- New crop modes with fixed aspect ratio and fixed crop size
- Set modification date to current date or to EXIF date
- New command: Ctrl-M to mark file for toggling. Use Ctrl+Left/Right to toggle between marked files
- Showing file name in window title
- Smooth blending in and out of the navigation panel if mouse not moved for some time
- Thumbnail view behavior changed somewhat - pan by click supported

[1.0.18] 2008-11-15
Bugs fixed:
- Resize now possible to sizes smaller than 800 x 600
- Renaming files with %x placeholder now works correctly
New features:
- Auto-rotate image using EXIF image orientation
- Save image in screen size (Ctrl-Shift-S)
- Keeping last selected image format when saving images
- Italian translation updated
- Toggle to window mode and back now first uses low quality sampling and improves quality on idle

[1.0.17] 2008-06-02
Bugs removed:
- Image processing panel no longer truncated on 1024x768 screens, sliders are smaller in this case
New features:
- Toggle screen with Ctrl-F12 on multiscreen systems
- Window mode, toggle between window mode and full screen mode with Ctrl-W or with button on navigation panel
  The window mode can be made default in INI file and the starting window size can also be set in the INI file
- New INI file setting (LandscapeModeParams) that allows defining the parameters used in landscape enhancement mode
- New INI file setting (BackgroundColor) that allows setting the background color
- New INI file setting (NavigateWithMouseWheel) that allows using the mouse wheel for navigation (Ctrl-Wheel for zoom)

[1.0.16.1] (repack - binary files equal to 1.0.16) 2008-02-12
New features:
- Italian translation (thanks to Max)

[1.0.16] 2008-02-12
Bugs removed:
- PNGs with transparency (alpha channel) are now rendered correctly. Other formats supporting alpha channel
  are rendered correctly when GDI+ can render them correctly - I have not tested this.
- The 'R' key for rotating lossless works again
- Navigation panel was not visible when OS regional settings did not use a point as decimal number separator
  (All other INI file settings represented by floating point numbers were also not read correctly in this case)
- Crash removed when scaling up images with height=1
- Cropping small areas (1 x n, n x 1) now possible
- Not using IJL for 1 channel JPEGs anymore - seems to crash sometimes. GDI+ is used for these images instead.
- Two bugs fixed causing crashes with very small images or images with extreme aspect ratio
New features:
- Support for multiple CPU cores. To set the number of cores to use to a specific value, set the CPUCoresUsed key
  to a specific value in the INI file. Default is to use all cores (max 4) of the CPU.
- Small thumbnail displayed when zooming, showing the visible section of the image. The section can be moved with
  the mouse in the thumbnail image. To disable this feature set ShowZoomNavigator=false in INI file.
- Spanish translation (thanks to Franco Bianconi)
- About dialog
- Tooltips for navigation panel buttons
- New button on navigation panel to switch to actual image size / fit to screen
- New INI file setting (Language=xx) to force user interface language (default is to use operating system language if supported by JPEGView)
- New INI file setting (StoreToEXEPath=true/false) forcing to write to config data and parameter DB to EXE path (used when installed on USB stick)

[1.0.15] 2007-12-27
Bugs removed:
- If using ClearType fonts, the button text on the image processing area is now rendered correctly
- EXIF information is now also found if not placed directly after SOI in JPEG image (e.g. after an APP0 block)
- File name flickering fixed in image processing area (was happening when file name was long)
- Zoom to 100% now always correctly zooms mouse cursor centered when the cursor is visible
New features:
- Display of EXIF information from digicam JPEG files (F2) - can be made permanently using the INI file
- Smoother screen update with less flickering by using back buffering of transparent areas
- Navigation panel blended into image. The navigation panel is turned on by default but can be disabled with the F11 key.
  To disable it permanently, press F11 then save the settings to the INI file with the context menu.
  The blending factor of the panel can be configured also in the INI file.
- New mode for optimal display of landscape pictures - lightens shadows and darkens highlights very progressively
  Use Ctrl-L to enable or the button on the navigation panel
Other changes:
- Using smaller font for help display (F1)
- Exclusion/inclusion folders for LDC and color correction: More specific folder overrides less specific when matching for inclusion
  and exclusion
- Using Crop without Ctrl pressed when image cannot be dragged
- New INI file entry: CreateParamDBEntryOnSave to disable/enable creation of a parameter DB entry for images saved in JPEGView

[1.0.14] 2007-11-09
Bugs removed:
- If a JPEG cannot be read with the IJL library, GDI+ is tried as a second chance
- Copy/rename dialog: Replacement text can now be longer than text input field (auto scroll enabled)
- Reader no longer crashes when stripe is negative for images read with GDI+
- Images with ending TIFF are no longer duplicated in file list
New features:
- File open... always uses thumbnail view (not only in 'my picture' directory)
- Saving files is now possible in the following formats: JPG, BMP, TIFF, PNG
- Copy/rename dialog: New placeholder %n for number from original file name
- Panning is faster and uses high quality resampling mode during pan
- New command to reload current image (Ctrl-R)
- Crop image section or zoom to image section with CTRL-Left mouse and dragging the mouse
- Paste image from clipboard (Ctrl-V)
Other changes:
- Color and contrast correction switched off in default INI file.
  It is recommended to switch it on for dedicated folders only, e.g. folders with digicam photos.
  Of course any user INI file remains untouched by this change.
- Due to an internal code simplification, all parameter DB entries for BMP images created with older versions
  are lost with 1.0.14. Note that other formats (e.g. JPG) are not affected.

[1.0.13] 2007-06-04
Bugs removed:
- Sorting by name now works correctly for names of the form X1 X1_y X2 X3
- When saving default values to INI file using the context menu, these default values are now immediately in effect for the next images
New features:
- File lists (text files) now support relative paths (relative to file list location)
- Movie mode enhanced and improved, now accessible using the context menu and automatically using fastest processing modes
- Batch rename/copy, allowing to copy and rename a series of files, e.g. from the digicam to the harddisk. Several placeholders are
  supported, e.g. file dates and consecutive numbers.
- Possibility to set the auto zoom mode, enabling to zoom images to fit the screen with or without border
Other changes:
- Keeping parameters between images (F4) will now override any values from the parameter DB while active.
  Note that while keeping parameters is on, storing to parameter DB is disabled.
- ICO removed from supported format list - GDI+ claims to be able to read it but can't

[1.0.12] 2007-05-08
First release to public
